.lf 1 sql/notify.cmdsrc
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" $Header: /usr/local/devel/pglite/cvs/src/doc/ref/sql/notify.cmdsrc,v 1.1 1996/02/24 01:17:09 jolly Exp $
.TH "NOTIFY" COMMANDS 11/05/95
.XA 2 "Notify"
.SH NAME
notify \(em signal all frontends and backends listening on a class
.SH SYNOPSIS
.(l M
\fBnotify\fR class_name
.)l
.SH DESCRIPTION
.BR notify
is used to awaken all backends and consequently all frontends
that have executed 
.IR listen (commands)
on
.IR class_name .
This can be used either within an instance-level rule as part of the
action body or from a normal query.  When used from within a normal
query, this can be thought of as interprocess communication (IPC).
When used from within a rule, this can be thought of as an alerter 
mechanism.
.PP
Notice that the mere fact that a 
.BR notify
has been executed does not imply anything in particular about
the state of the class (e.g., that it has been updated), nor
does the notification protocol transmit any useful information 
other than the class name.  Therefore, all
.BR notify
does is indicate that some backend wishes its peers to examine
.IR class_name
in some application-specific way.
.PP
This event notification is performed through the \*(LI protocol
and frontend application interface.  The application program
must explicitly poll a \*(LI global variable,
.IR PQAsyncNotifyWaiting ,
and call the routine
.IR PQnotifies
in order to find out the name of the class to which a given
notification corresponds.  If this code is not included in 
the application, the event notification will be queued and 
never be processed.
.SH "SEE ALSO"
define rule(commands),
listen(commands),
libpq.
